<template>
  <b-modal
    id="add-user-modal"
    v-model="openModal"
    size="md"
    title="Supprimer une ressource"
  >
    <div>
      <b-overlay
        id="overlay-background"
        :show="loading"
        :variant="'white'"
        :opacity="0.7"
        :blur="'2px'"
        rounded="sm"
      >
        <p v-if="resource">La ressource <strong>{{ resource['Nom'] }}</strong> sera définitivement supprimée.</p>
        <p>Etes-vous sûr de vouloir continuer?</p>
      </b-overlay>
    </div>
    <template #modal-footer>
      <div class="w-100">
        <b-button
          variant="outline-secondary"
          class="float-left"
          @click="hide"
        >
          Annuler
        </b-button>
        <b-button
          variant="primary"
          class="float-right"
          @click="deleteResource"
        >
          Confirmer
        </b-button>
      </div>
    </template>
  </b-modal>
</template>

<script>
import { mapActions } from 'vuex';

export default {
  name: 'DeleteResource',

  props: {
    open: {
      type: Boolean,
      default: false
    },
    resource: {
      type: Object,
      default: () => { return {} }
    }
  },

  data() {
    return {
      openModal: false,
      loading: false
    }
  },

  watch: {
    open: function(newValue) {
      this.resetModal();
      this.openModal = newValue;
    }
  },

  methods: {
    ...mapActions('resources', [
      'DELETE_RESOURCE'
    ]),

    resetModal() {
      this.openModal = false;
      this.loading = false;

    },
    deleteResource() {
      this.loading = true;
      this.DELETE_RESOURCE(this.resource)
        .then(() => {
          this.loading = false;
          this.$emit('update');
          this.$emit('hide');
        }).catch(() => {
          this.loading = false;
          this.$emit('hide');
        });
    },
    hide() {
      this.$emit('hide');
    }
  }
}
</script>

<style lang="less" scoped>

h2 {
  color: @blue;
  margin-top: 0.8em;
  margin-left: 0.5em;
}

h4 {
  color: @blue;
  margin-top: 0.8em;
}

</style>
